//=============================================================================
// Bandoneon, 142 Button, Rheinische Tonlage - Plugin for MuseScore
// Copyright © 2023 Dave Ludlow
// License: https://www.gnu.org/licenses/gpl-3.0.en.html
//=============================================================================

import QtQuick 2.2
import MuseScore 3.0

MuseScore {

      //=============================================================================
      // Meta info

      version: "0.1"
      description: "Fingering for 142 button Rheinische Tonlage Bandoneon"
      menuPath: "Plugins.Bandoneon-142-Rheinische"
      requiresScore: true

      pluginType: "dialog"
      width: 440
      height: 380

      onRun: {
            if (typeof curScore === 'undefined')
                  Qt.quit();

            //console.log(objToString(this));
            return;
      }

      onScoreStateChanged: {
            drawButtons(this);

            function drawButtons(parentObj) {
                  var buttons_treble = [
                        {
                              x: 0.000,
                              y: 0.000,
                              pitch_open: 58,
                              pitch_close: 58,
                              opening: false,
                              closing: false,
                        },{
                              x: 0.663,
                              y: 1.926,
                              pitch_open: 63,
                              pitch_close: 63,
                              opening: false,
                              closing: false,
                        },{
                              x: 0.987,
                              y: 3.819,
                              pitch_open: 77,
                              pitch_close: 77,
                              opening: false,
                              closing: false,
                        },{
                              x: 1.191,
                              y: 5.784,
                              pitch_open: 75,
                              pitch_close: 76,
                              opening: false,
                              closing: false,
                        },{
                              x: 1.138,
                              y: 7.721,
                              pitch_open: 78,
                              pitch_close: 80,
                              opening: false,
                              closing: false,
                        },{
                              x: 0.954,
                              y: 9.659,
                              pitch_open: 81,
                              pitch_close: 83,
                              opening: false,
                              closing: false,
                        },{
                              x: 0.706,
                              y: 11.650,
                              pitch_open: 85,
                              pitch_close: 88,
                              opening: false,
                              closing: false,
                        },{
                              x: -0.038,
                              y: 13.384,
                              pitch_open: 79,
                              pitch_close: 75,
                              opening: false,
                              closing: false,

                        },{
                              x: 1.562,
                              y: -0.604,
                              pitch_open: 57,
                              pitch_close: 57,
                              opening: false,
                              closing: false,
                        },{
                              x: 2.056,
                              y: 1.213,
                              pitch_open: 65,
                              pitch_close: 65,
                              opening: false,
                              closing: false,
                        },{
                              x: 2.342,
                              y: 3.285,
                              pitch_open: 70,
                              pitch_close: 64,
                              opening: false,
                              closing: false,
                        },{
                              x: 2.524,
                              y: 5.115,
                              pitch_open: 68,
                              pitch_close: 69,
                              opening: false,
                              closing: false,
                        },{
                              x: 2.539,
                              y: 7.080,
                              pitch_open: 71,
                              pitch_close: 73,
                              opening: false,
                              closing: false,
                        },{
                              x: 2.430,
                              y: 9.044,
                              pitch_open: 74,
                              pitch_close: 76,
                              opening: false,
                              closing: false,
                        },{
                              x: 2.069,
                              y: 11.009,
                              pitch_open: 80,
                              pitch_close: 81,
                              opening: false,
                              closing: false,
                        },{
                              x: 1.557,
                              y: 12.866,
                              pitch_open: 83,
                              pitch_close: 85,
                              opening: false,
                              closing: false,

                        },{
                              x: 3.446,
                              y: 0.665,
                              pitch_open: 59,
                              pitch_close: 59,
                              opening: false,
                              closing: false,
                        },{
                              x: 3.780,
                              y: 2.590,
                              pitch_open: 64,
                              pitch_close: 66,
                              opening: false,
                              closing: false,
                        },{
                              x: 4.007,
                              y: 4.487,
                              pitch_open: 73,
                              pitch_close: 78,
                              opening: false,
                              closing: false,
                        },{
                              x: 3.980,
                              y: 6.505,
                              pitch_open: 66,
                              pitch_close: 67,
                              opening: false,
                              closing: false,
                        },{
                              x: 3.847,
                              y: 8.443,
                              pitch_open: 69,
                              pitch_close: 71,
                              opening: false,
                              closing: false,
                        },{
                              x: 3.406,
                              y: 10.300,
                              pitch_open: 72,
                              pitch_close: 74,
                              opening: false,
                              closing: false,
                        },{
                              x: 2.925,
                              y: 12.238,
                              pitch_open: 76,
                              pitch_close: 79,
                              opening: false,
                              closing: false,
                        },{
                              x: 4.715,
                              y: 1.486,
                              pitch_open: 60,
                              pitch_close: 62,
                              opening: false,
                              closing: false,
                        },{
                              x: 4.996,
                              y: 3.472,
                              pitch_open: 62,
                              pitch_close: 61,
                              opening: false,
                              closing: false,
                        },{
                              x: 5.103,
                              y: 5.583,
                              pitch_open: 67,
                              pitch_close: 68,
                              opening: false,
                              closing: false,
                        },{
                              x: 4.996,
                              y: 7.654,
                              pitch_open: 82,
                              pitch_close: 70,
                              opening: false,
                              closing: false,
                        },{
                              x: 4.689,
                              y: 9.649,
                              pitch_open: 84,
                              pitch_close: 72,
                              opening: false,
                              closing: false,
                        },{
                              x: 4.301,
                              y: 11.557,
                              pitch_open: 86,
                              pitch_close: 86,
                              opening: false,
                              closing: false,

                        },{
                              x: 5.798,
                              y: 2.376,
                              pitch_open: 61,
                              pitch_close: 60,
                              opening: false,
                              closing: false,
                        },{
                              x: 6.025,
                              y: 4.568,
                              pitch_open: 93,
                              pitch_close: 91,
                              opening: false,
                              closing: false,
                        },{
                              x: 6.119,
                              y: 6.679,
                              pitch_open: 90,
                              pitch_close: 82,
                              opening: false,
                              closing: false,
                        },{
                              x: 5.958,
                              y: 8.844,
                              pitch_open: 88,
                              pitch_close: 84,
                              opening: false,
                              closing: false,
                        },{
                              x: 5.477,
                              y: 10.862,
                              pitch_open: 87,
                              pitch_close: 87,
                              opening: false,
                              closing: false,

                        },{
                              x: 6.880,
                              y: 3.392,
                              pitch_open: 95,
                              pitch_close: 93,
                              opening: false,
                              closing: false,
                        },{
                              x: 7.014,
                              y: 5.686,
                              pitch_open: 92,
                              pitch_close: 92,
                              opening: false,
                              closing: false,
                        },{
                              x: 6.947,
                              y: 7.948,
                              pitch_open: 91,
                              pitch_close: 90,
                              opening: false,
                              closing: false,
                        },{
                              x: 6.626,
                              y: 10.100,
                              pitch_open: 89,
                              pitch_close: 89,
                              opening: false,
                              closing: false,
                        },
                  ];

                  var buttons_bass = [
                        {
                              x: 0.000,
                              y: 0.000,
                              pitch_open: 36,
                              pitch_close: 41,
                              opening: false,
                              closing: false,
                        },{
                              x: -0.668,
                              y: 2.405,
                              pitch_open: 39,
                              pitch_close: 37,
                              opening: false,
                              closing: false,
                        },{
                              x: -1.002,
                              y: 4.731,
                              pitch_open: 54,
                              pitch_close: 53,
                              opening: false,
                              closing: false,
                        },{
                              x: -1.176,
                              y: 7.043,
                              pitch_open: 63,
                              pitch_close: 71,
                              opening: false,
                              closing: false,
                        },{
                              x: -1.176,
                              y: 9.488,
                              pitch_open: 69,
                              pitch_close: 68,
                              opening: false,
                              closing: false,
                        },{
                              x: -0.922,
                              y: 11.853,
                              pitch_open: 67,
                              pitch_close: 66,
                              opening: false,
                              closing: false,
                        },{
                              x: -0.307,
                              y: 14.165,
                              pitch_open: 47,
                              pitch_close: 52,
                              opening: false,
                              closing: false,
                        },{
                              x: 0.174,
                              y: 15.969,
                              pitch_open: 38,
                              pitch_close: 40,
                              opening: false,
                              closing: false,

                        },{
                              x: -1.403,
                              y: 0.802,
                              pitch_open: 42,
                              pitch_close: 47,
                              opening: false,
                              closing: false,
                        },{
                              x: -2.138,
                              y: 3.261,
                              pitch_open: 61,
                              pitch_close: 56,
                              opening: false,
                              closing: false,
                        },{
                              x: -2.365,
                              y: 5.573,
                              pitch_open: 66,
                              pitch_close: 64,
                              opening: false,
                              closing: false,
                        },{
                              x: -2.619,
                              y: 7.818,
                              pitch_open: 62,
                              pitch_close: 61,
                              opening: false,
                              closing: false,
                        },{
                              x: -2.472,
                              y: 10.277,
                              pitch_open: 59,
                              pitch_close: 57,
                              opening: false,
                              closing: false,
                        },{
                              x: -2.138,
                              y: 12.669,
                              pitch_open: 56,
                              pitch_close: 52,
                              opening: false,
                              closing: false,
                        },{
                              x: -1.536,
                              y: 14.940,
                              pitch_open: 52,
                              pitch_close: 45,
                              opening: false,
                              closing: false,

                        },{
                              x: -2.859,
                              y: 1.617,
                              pitch_open: 43,
                              pitch_close: 54,
                              opening: false,
                              closing: false,
                        },{
                              x: -3.528,
                              y: 3.956,
                              pitch_open: 48,
                              pitch_close: 65,
                              opening: false,
                              closing: false,
                        },{
                              x: -3.848,
                              y: 6.308,
                              pitch_open: 64,
                              pitch_close: 62,
                              opening: false,
                              closing: false,
                        },{
                              x: -3.955,
                              y: 9.226,
                              pitch_open: 60,
                              pitch_close: 59,
                              opening: false,
                              closing: false,
                        },{
                              x: -3.862,
                              y: 11.092,
                              pitch_open: 57,
                              pitch_close: 55,
                              opening: false,
                              closing: false,
                        },{
                              x: -3.407,
                              y: 13.457,
                              pitch_open: 50,
                              pitch_close: 43,
                              opening: false,
                              closing: false,

                        },{
                              x: -3.394,
                              y: 0.027,
                              pitch_open: 41,
                              pitch_close: 42,
                              opening: false,
                              closing: false,
                        },{
                              x: -4.142,
                              y: 2.472,
                              pitch_open: 58,
                              pitch_close: 48,
                              opening: false,
                              closing: false,
                        },{
                              x: -4.690,
                              y: 4.971,
                              pitch_open: 65,
                              pitch_close: 61,
                              opening: false,
                              closing: false,
                        },{
                              x: -4.917,
                              y: 7.457,
                              pitch_open: 51,
                              pitch_close: 60,
                              opening: false,
                              closing: false,
                        },{
                              x: -4.971,
                              y: 9.942,
                              pitch_open: 55,
                              pitch_close: 58,
                              opening: false,
                              closing: false,
                        },{
                              x: -4.543,
                              y: 12.522,
                              pitch_open: 45,
                              pitch_close: 50,
                              opening: false,
                              closing: false,

                        },{
                              x: -4.664,
                              y: 0.922,
                              pitch_open: 68,
                              pitch_close: 67,
                              opening: false,
                              closing: false,
                        },{
                              x: -5.305,
                              y: 3.434,
                              pitch_open: 53,
                              pitch_close: 63,
                              opening: false,
                              closing: false,
                        },{
                              x: -5.679,
                              y: 6.107,
                              pitch_open: 49,
                              pitch_close: 51,
                              opening: false,
                              closing: false,
                        },{
                              x: -5.786,
                              y: 8.686,
                              pitch_open: 46,
                              pitch_close: 46,
                              opening: false,
                              closing: false,
                        },{
                              x: -5.546,
                              y: 11.426,
                              pitch_open: 44,
                              pitch_close: 44,
                              opening: false,
                              closing: false,
                        }
                  ];

                  var bsize = width/25;
                  var xcenter = (width/2) - 30;
                  var xofs = 40;
                  var yofs_treble = 30;
                  var yofs_bass = 0;
                  var color_opening = "yellow"
                  var color_closing = "red"
                  var color_both = "cyan"
                  var color_neither = "white"
            
                  var qtbuttons = [];

                  for (var i in buttons_treble) {
                        var b = Qt.createQmlObject('
                              import QtQuick 2.0

                              Rectangle {
                                    color: "' + color_neither + '"
                                    border.color: "black"
                                    width: ' + bsize + '
                                    height: ' + bsize + '
                                    x: ' + (xcenter + xofs + parseInt(20+20*(buttons_treble[i].x))) + '
                                    y: ' + (yofs_treble + parseInt(20+20*(buttons_treble[i].y))) + '
                              }
                              ',
                              parentObj,
                              "dynamicButton"
                        );
                        qtbuttons.push(b);
                  }

                  for (var i in buttons_bass) {
                        var b = Qt.createQmlObject('
                              import QtQuick 2.0

                              Rectangle {
                                    color: "' + color_neither + '"
                                    border.color: "black"
                                    width: ' + bsize + '
                                    height: ' + bsize + '
                                    x: ' + (xcenter - xofs + parseInt(20+20*(buttons_bass[i].x))) + '
                                    y: ' + (yofs_bass + parseInt(20+20*(buttons_bass[i].y))) + '
                              }
                              ',
                              parentObj,
                              "dynamicButton"
                        );
                        qtbuttons.push(b);
                  }

                  for (var i in curScore.selection.elements) {
                        var e = curScore.selection.elements[i];
                        if (e.name == "Note") {
                              //console.log("Pitch = " + e.pitch);
                              //console.log("TPC = " + e.tpc);
                              //console.log(objToString(e));
                              for (var i in buttons_treble) {
                                    buttons_treble[i].opening |= e.pitch == buttons_treble[i].pitch_open;
                                    buttons_treble[i].closing |= e.pitch == buttons_treble[i].pitch_close;
                              }
                              for (var i in buttons_bass) {
                                    buttons_bass[i].opening |= e.pitch == buttons_bass[i].pitch_open;
                                    buttons_bass[i].closing |= e.pitch == buttons_bass[i].pitch_close;
                              }


                              for (var i in buttons_treble) {
                                    var qti = i;
                                    if ( buttons_treble[i].opening && buttons_treble[i].closing) {
                                          qtbuttons[qti].color=color_both;
                                    } else if ( buttons_treble[i].opening ) {
                                          qtbuttons[qti].color=color_opening;
                                    } else if ( buttons_treble[i].closing ) {
                                          qtbuttons[qti].color=color_closing;
                                    }
                              }
                              for (var i in buttons_bass) {
                                    var qti = parseInt(i) + parseInt(buttons_treble.length);
                                    if ( buttons_bass[i].opening && buttons_bass[i].closing) {
                                          qtbuttons[qti].color=color_both;
                                    } else if ( buttons_bass[i].opening ) {
                                          qtbuttons[qti].color=color_opening;
                                    } else if ( buttons_bass[i].closing ) {
                                          qtbuttons[qti].color=color_closing;
                                    }
                              }

                        } else {
                              //console.log("Ignoring " + e.name);
                              //console.log(objToString(e));
                        }
                  }
            }

            function objToString(obj) {
                  var str = '';
                  for (var p in obj) {
                        if (Object.prototype.hasOwnProperty.call(obj, p)) {
                              str += p + '::' + obj[p] + '\n';
                        }
                  }
                  return str;
            }
      }
}
